/*
 * $Id: RunAs.js,v 1.3 2005/11/11 19:06:42 jbarrera Exp $
 *
 * Copyright 2004-2005 Collation Inc. All Rights Reserved
 *
 * This software is the proprietary information of Collation Inc.
 * Use is subject to license terms.
 */

function run(command) {
    debug("RunAs: command=[" + command + "]");
    //var temp = wsh.Environment("SYSTEM")("TEMP");
    var temp = "c:\\";
    if (temp.substring(temp.length - 1) != "\\") {
        temp += "\\";
    }
    var tempfile = temp + "runas." + (new Date()).getTime();
    command += " 2>&1 <nul: >" + tempfile;
    rv = wsh.Run(command, 0, true);
    var f = fso.OpenTextFile(tempfile, 1);
    //println(f.readAll());
	WScript.StdOut.WriteLine(f.readAll());
    f.Close();
    fso.DeleteFile(tempfile, true);
    return rv;
}

function main() {
    var args = getArgs(1, -1);

    var command = "cmd.exe /c";
    for (var i = 0; i < args.length; i++) {
        debug("arg[" + i + "]=" + args[i]);
        command += " ";
        command += args[i];
        if (args[i] == "cscript") {
            command += " //nologo";
        }
    }
    if (wmi_username != null && wmi_username.indexOf("\\") == -1 && wmi_domain != null) {
        wmi_username = wmi_domain + "\\" + wmi_username;
    }

    var here = getenv("USERDOMAIN");
    here += "\\";
    here += getenv("USERNAME");
    here += "@";
    here += getenv("COMPUTERNAME");

    var there = wmi_username + "@" + hostname;
    var prefix = "RunAs from [" + here + "] to [" + there + "]: ";

    var scriptname = args[1];
    if (scriptname == "adsidump.wsf" || scriptname == "adsienum.wsf") {
        var path = args[3];
        if (path.indexOf(" ") != -1) {
            path = "\"" + path + "\"";
        }
        command = "cmd.exe /c TaddmTool.exe @" + hostname + " ";
        if (scriptname == "adsidump.wsf") {
            command += "AdsiDump " + path;
        } else {
            var type = args[4];
            command += "AdsiEnum " + path + " " + type;
        }
    } else {
        debug(prefix + "begin");
        if (hostname != ".") {
            share = "\\\\" + hostname + "\\ipc$";
            smb.MapNetworkDrive("", share, false, wmi_username, wmi_password);
            debug(prefix + "mapped share " + share);
        }
    }
    debug(prefix + "about to run [" + command + "]");
    var status = run(command);
    debug(prefix + "exit(" + status + ")");
    exit(status);
}
