/*
 * $Id: InstallProvider.js,v 1.1.2.2 2006/03/15 19:24:27 jbarrera Exp $
 *
 * Copyright 2004-2005 Collation Inc. All Rights Reserved
 *
 * This software is the proprietary information of Collation Inc.
 * Use is subject to license terms.
 */

var stoppedWMI = false;

function copyToWbemDir(wbemdir, filename, deleteFirst) {
    var overwrite = true;
    wbemdir += "\\";

    if (deleteFirst) {
        var oldpath = wbemdir + filename;
        var newpath = oldpath + "." + (new Date()).getTime();

        debug("Moving " + oldpath + " to " + newpath);
        try {
            fso.MoveFile(oldpath, newpath);
        } catch (e) {
            debug("*** Error moving " + oldpath + " to " + newpath + ": " + e.description);
        }

        var newpaths = oldpath + "*";
        debug("Deleting " + newpaths);
        try {
            fso.DeleteFile(newpaths, true);
        } catch (e) {
            debug("*** Error deleting " + newpaths + ": " + e.description);
        }
    }

    debug("Copying " + filename + " to " + wbemdir);
    try {
        fso.CopyFile(filename, wbemdir, overwrite);
    } catch (e) {
        debug("*** Error copying " + filename + " to " + wbemdir + ": " + e.description);
    }
}

function main() {
    var args = getArgs(0, 0);

    // Fetch the system directory
    var os = wmiQueryFirst("Select * from Win32_OperatingSystem");
    wbemdir = getValue(os, "SystemDirectory") + "\\wbem";

    // Copy files to remote machine.
    var wbemdir1 = wbemdir;
    if (hostname != ".") {
        wbemdir1 = "\\\\" + hostname + "\\admin$\\System32\\wbem";
        smb.MapNetworkDrive("", wbemdir1, false, wmi_username, wmi_password);
    }
    copyToWbemDir(wbemdir1, "Win32_Confignia.dll", true);
    copyToWbemDir(wbemdir1, "Win32_Confignia.mof", true);
    copyToWbemDir(wbemdir1, "ConfigniaLog.dll", false);
    copyToWbemDir(wbemdir1, "aports.dll", false);
    copyToWbemDir(wbemdir1, "msvcr71.dll", false);
    copyToWbemDir(wbemdir1, "adsi.js", true);
    if (hostname != ".") {
        smb.RemoveNetworkDrive(wbemdir1);
    }

    // Now register or compile the files on the remote machine.
    createProcess(wbemdir + "\\mofcomp.exe " + wbemdir + "\\Win32_Confignia.mof");
    createProcess("regsvr32 /s " + wbemdir + "\\Win32_Confignia.dll");
}
